<% 
Class CSV2MDB

    Public FirstLineContainsFieldNames
    Public UseTextQualifier
    Public CreateNewDB
    Public TableExists
    
    Public Sub ConvertToMDB(ByVal strMDBPath, ByVal strTableName, ByVal strCSVPath, ByVal strCSVFileName)
    
    Const ForReading = 1
    Const ForWriting = 2
    
    strCVSFileFullPath = strCSVPath & strCSVFileName
    
    strDB = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & strMDBPath
    strSQL = "INSERT INTO " & strTableName & " SELECT * FROM [" & strCSVFileName
    strSQL = strSQL &  "] IN """ & strCSVPath & """ ""TEXT;"""
    
    If (CreateNewDB) Then
        Set objNewCatalog = Server.CreateObject("ADOX.Catalog") 
        objNewCatalog.Create strDB
        Set objNewCatalog = Nothing
    End If
    
    
    If (TableExists) Then  
        Set objCreateTableConn = Server.CreateObject("ADODB.Connection")
        objCreateTableConn.Open strDB
        objCreateTableConn.Execute "DROP TABLE " & strTableName
        objCreateTableConn.Close
        Set objCreateTableConn = Nothing
    End If   
    
    Set objCatalog = Server.CreateObject("ADOX.Catalog")
    objCatalog.ActiveConnection = strDB
    Set objTable = Server.CreateObject("ADOX.Table")
    Set fso = Server.CreateObject("Scripting.FileSystemObject")
    objTable.Name = strTableName
    objCatalog.Tables.Append objTable

    Set CVSFile = fso.OpenTextFile(strCVSFileFullPath, ForReading)
    strFields = CVSFile.ReadLine
    CVSFile.Close
    Set CVSFile = Nothing
    Set fso = Nothing
        
    If (FirstLineContainsFieldNames) Then
        
        If (UseTextQualifier) Then
            strFields = Replace(strFields, """","")
        End If    
        
        arFields = Split(strFields,",")
        
        For Each item In arFields
           objTable.Columns.Append item
        Next
    
    Else
        arFields = Split(strFields,",")
        nCount = 0
        
        For Each item In arFields
           nCount = nCount + 1
           objTable.Columns.Append "Field" & nCount
           
        Next
        
    End If    
    
    Set objTable = Nothing
    Set objCatalog = Nothing
    
    Set objConn = Server.CreateObject("ADODB.Connection")
    objConn.Open strDB
    
    If Not (FirstLineContainsFieldNames) Then
        Set objFSO = Server.CreateObject("Scripting.FileSystemObject")
        Set objTempFile = objFSO.OpenTextFile(strCSVPath & "temp.csv", ForWriting, True)
        
        If (UseTextQualifier) Then
            For n=1 To nCount
                objTempFile.Write """Field" & n
                If n <> nCount Then
                    objTempFile.Write ""","
                End If  
            Next
        Else
            For n=1 To nCount
                objTempFile.Write "Field" & n
                If n <> nCount Then
                    objTempFile.Write ","
                End If
            Next
        End If
        
        objTempFile.Write """"
        objTempFile.WriteBlankLines(1)
        
        Set CVSFile = objFSO.OpenTextFile(strCVSFileFullPath, ForReading)
        strCVSContent = CVSFile.ReadAll
        CVSFile.Close
        Set CVSFile = Nothing
        
        objTempFile.Write strCVSContent
        objTempFile.Close
        
        strSQLAlt = "INSERT INTO " & strTableName & " SELECT * FROM [temp.csv"
        strSQLAlt = strSQLAlt &  "] IN """ & strCSVPath & """ ""TEXT;"""
        
        objConn.Execute strSQLAlt
        
        Set objTempFile = objFSO.GetFile(strCSVPath & "temp.csv")
        objTempFile.Delete
        Set objTempFile = Nothing
        Set objFSO = Nothing
    Else
        objConn.Execute strSQL
    End If
    objConn.Close
    Set objConn = Nothing
    End Sub
End Class
%>